; Designed by Robin S. Rowe  312-280-7693
; Rowe Software, 1313 N. Ritchie Ct., #1707, Chicago, IL  60610

;------------------------------  GetFax()  ----------------- 11/27/91
;	Imports Techfax text into Paradox tables.
;	Techfax zip files are presumed to be in current directory.
;	Copy of PKUnzip.exe is presumed to be in current directory.

PROC GetFax()
PRIVATE name,		; name of text file to import.
        blanks,	; number of blank lines.
        title,	; title of text file.
        date,		; date of text file.
        dos_command; dos command to unzip zip file.
CLEAR
@2,0
TEXT
GetFax.sc imports Techfax zip files into Paradox TechFax Online Help System.
        by Robin S. Rowe (Rowe Software) 1991-1992, not copyrighted.

To unzip the Borland TECH*.ZIP files, they should be in this directory with a 
copy of PKUNZIP.EXE.  After being unzipped, any *.ASC files will be imported.

To escape at any time, press [Esc] and wait for program to terminate.
ENDTEXT
MESSAGE "Press any key to continue"
CANVAS ON
retval=GETCHAR()
IF retval=27
THEN
	QUIT "Program terminated by user"
ENDIF
SWITCH
CASE DRIVESPACE(SUBSTR(DIRECTORY(),1,1))<2000000:
	QUIT "Won't unzip TechFax with less than 2 meg free"
CASE NOT ISTABLE("Techfax"):
	QUIT "Techfax table missing"
CASE NOT ISTABLE("Techlist"):
	QUIT "Techlisttable missing"
CASE NOT ISTABLE("Link"):
	QUIT "Link table missing"
CASE NOT ISEMPTY("Techfax"):
	SHOWMENU
"Empty"     :	"Empty existing data from TechFax table",
"Overwrite" :	"Overwrite existing data in TechFax table with new data"
		TO name
	IF NOT retval
	THEN
		QUIT "Program terminated by user"
	ENDIF
	IF name="Empty"
	THEN
		MESSAGE "Emptying tables"
		CANVAS OFF
		EMPTY "TechFax"
		EMPTY "Techlist"
		EMPTY "Link"
		IF VERSION()>=3.5
		THEN
			EXECUTE "SAVETABLES"
		ENDIF
	ENDIF
ENDSWITCH
MESSAGE "Looking for TECH*.ZIP files"
CANVAS ON CANVAS OFF
MENU {Tools}{Info}{Inventory}{Files}
SELECT "Tech*.zip"
CANVAS ON
IF NIMAGERECORDS()>0
THEN
	ECHO FAST ECHO OFF
	SHOWMENU
"UnZip"	 : "Will use PKUNZIP to unzip these files for import",
"Continue": "Don't unzip these files, import READ.ME or *.ASC files only"
		TO name
	SWITCH
	CASE NOT retval:
		QUIT "Program terminated by user"
	CASE name="UnZip":
		IF NOT ISFILE("Pkunzip.exe")
		THEN
			QUIT "PKUNZIP.EXE not found in "+DIRECTORY()
		ENDIF
		SCAN
			dos_command="Pkunzip "+[Name]
			RUN dos_command
		ENDSCAN
	ENDSWITCH
ENDIF
MESSAGE "Looking for *.ASC files"
CANVAS OFF
MENU {Tools}{Info}{Inventory}{Files}
SELECT "*.asc"
CANVAS ON
IF NIMAGERECORDS()=0 AND NOT ISFILE("Read.me")
THEN
	DELETE "List"
	DELETE "Import"
	QUIT "No TechFax *.ASC files to import"
ENDIF
IF NOT ISTABLE("Techlist")
THEN
	QUIT "Techlist table not found or damaged"
ENDIF
VIEW "Techlist"
IF ISFILE("Read.me")
THEN
	COEDITKEY
	INS
	[File]="Read.me"
	[Date]=TODAY()
	[Title]="How to Use the TechFax System"
	LOCKRECORD
	UNLOCKRECORD
	UNLOCKRECORD
	MOVETO "List"
	INS
	[Name]="Read.me"
	LOCKRECORD
	UNLOCKRECORD
	UNLOCKRECORD
	DO_IT!
ENDIF
MESSAGE "Creating Import table"
CANVAS OFF
CREATE "Import"
	"File"		: "A12",
	"Line#"		: "S",
	"Text"		: "A80"
VIEW "Import"
MOVETO "List"
SCAN
	IF CHARWAITING() AND GETCHAR()=27
	THEN
		QUIT "Program terminated by user"
	ENDIF
	name=[Name]
	date=[Date]
	MESSAGE "Importing "+name
	CANVAS ON CANVAS OFF
	MENU "teiat"	; Import text
	SELECT name
	SELECT "Answer"
	"r"
	EMPTY "Import"
	IF VERSION()>=3.5
	THEN
		EXECUTE "SAVETABLES"
	ENDIF
	MENU "A"
	SELECT "Answer"
	[Text]="_1"
	MENU "A"
	SELECT "Import"
	"Insert"
	[Text]="_1"
	DO_IT!
	CLEARIMAGE
	MOVETO 1
	CLEARIMAGE
	MOVETO "Import"
	COEDITKEY
	blanks=1
	title=""
	WHILE TRUE
		IF ISBLANK([Text])
		THEN
			IF blanks>0
			THEN
				DEL
				IF RECNO()>1
				THEN
					blanks=blanks+1
				ENDIF
				IF ATLAST()
				THEN
					QUITLOOP
				ELSE
					LOOP
				ENDIF
			ELSE
				blanks=1
			ENDIF
		ELSE
			IF ISBLANK(title) AND SEARCH("TITLE",[Text])>0
			THEN
				SKIP
				title=[Text]
				WHILE SUBSTR(title,1,1)=" "
					title=SUBSTR(title,2,255)
				ENDWHILE
				SKIP -1
				title=[Text]+" "+title
			ENDIF
			IF blanks>5
			THEN
				IF SEARCH("PRODUCT",[Text])>0
				THEN
					DEL
					IF SEARCH("VERSION",[Text])>0
					THEN
						DEL
						SKIP -2
						IF SUBSTR([Text],LEN([Text]),1)="."
						OR SUBSTR([Text],LEN([Text]),1)=":"
						THEN
							SKIP 2
						ELSE
							SKIP
							DEL
						ENDIF
					ELSE
						UNDO
						blanks=1
						LOOP
					ENDIF
					WHILE ISBLANK([Text])
						DEL
					ENDWHILE
					IF SEARCH("OS",[Text])>0
					THEN
						DEL
					ELSE
						blanks=1
						LOOP
					ENDIF
					WHILE ISBLANK([Text])
						DEL
					ENDWHILE
					IF SEARCH("DATE",[Text])>0
					THEN
						DEL
					ELSE
						blanks=1
						LOOP
					ENDIF
					WHILE ISBLANK([Text])
						DEL
					ENDWHILE
					IF SEARCH(" TITLE",[Text])>0
					THEN
						DEL
					ELSE
						blanks=1
					ENDIF
					LOOP
				ENDIF
			ENDIF
			blanks=0
			IF RECNO()=1
			THEN
				IF [Text]=FILL(" ",LEN([Text])) 
				THEN
					DEL
					LOOP
				ENDIF
				offset=1	; Calculating leading white space.
				WHILE SUBSTR([Text],offset,1)=" "
					offset=offset+1
				ENDWHILE
			ENDIF
		ENDIF
		[File]=name
		[Line#]=RECNO()
		[Text]=SUBSTR([Text],offset,255)	; Trim leading spaces.
		IF ATLAST()
		THEN
			QUITLOOP
		ENDIF
		SKIP
	ENDWHILE
	MOVETO "Techlist"
	INS
	[File]=name
	KEYLOOKUP
	LOCKRECORD
	LOCKRECORD
	IF ISBLANK([Title])
	THEN
		[Date]=date
		offset=SEARCH("TITLE",title)
		IF offset>0
		THEN
			title=SUBSTR(title,offset+5,255)
			offset=SEARCH(":",title)
			IF offset>0 AND offset<5
			THEN
				title=SUBSTR(title,offset+1,255)
			ENDIF
		ENDIF
		offset=1	; Calculating leading white space.
		WHILE SUBSTR(title,offset,1)=" "
			offset=offset+1
		ENDWHILE
		title=SUBSTR(title,offset,255)
		IF title=UPPER(title)
		THEN
			title=FORMAT("cc",LOWER(title))
		ENDIF
		[Title]=title
		LOCKRECORD
		LOCKRECORD
		UNLOCKRECORD
	ENDIF
	MOVETO "List"
	DO_IT!
	ADD "Import" "Techfax"
	CLEARIMAGE
	MOVETO "List"
	MOVETO FIELD "Name"
	LOCATE name
ENDSCAN
MESSAGE "Deleting List and Import tables"
CANVAS ON CANVAS OFF
DELETE "List"
DELETE "Import"
CANVAS ON
SHOWMENU
	"Delete" 	: "Delete all *.ASC files",
	"Continue": "Don't delete *.ASC files"
	TO name
SWITCH
CASE NOT retval:
	QUIT "Program terminated by user"
CASE name="Delete":
	dos_command="DEL *.asc"
	MESSAGE "Deleting *.ASC files"
	CANVAS OFF
	RUN NOREFRESH NORESTORE dos_command
	CANVAS ON
ENDSWITCH
RESET
IF DRIVESPACE(SUBSTR(DIRECTORY(),1,1))>4*FILESIZE("Techfax.db")
THEN
	SHOWMENU
	"Pack"	: "Compress tables to save diskspace",
	"Continue": "Don't compress tables"
	TO name
	IF name="Pack"
	THEN
		MESSAGE "Compressing Techfax.db"
		CANVAS ON CANVAS OFF
		MENU "a"
		SELECT "Techfax"
		CHECKPLUS
		DO_IT!
		EMPTY "Techfax"
		CLEARALL
		IF VERSION()>=3.5
		THEN
			EXECUTE "SAVETABLES"
		ENDIF
		ADD "Answer" "Techfax"
		MESSAGE "Compressing Techlist.db"
		CANVAS ON CANVAS OFF
		MENU "a"
		SELECT "Techlist"
		CHECKPLUS
		DO_IT!
		EMPTY "Techlist"
		CLEARALL
		IF VERSION()>=3.5
		THEN
			EXECUTE "SAVETABLES"
		ENDIF
		ADD "Answer" "Techlist"
		RESET
	ENDIF
ELSE
QUIT " Program completed. Insufficient disk space to optionally pack tables"
ENDIF				
RETURN " Program completed. Play TechFax script to view. "
ENDPROC

GetFax()
RELEASE PROCS GetFax